#!/usr/bin/perl -w
use strict;

################################################################################
# Trombi - Copyright 2007-2008 Louis Paternault
# 
# This file is part of Trombi.
# 
# Trombi is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Trombi is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Trombi.  If not, see <http://www.gnu.org/licenses/>.
################################################################################

# Genere le fichier source accent.adb en se servant de la liste de diacritiques donnees dans le fichier "liste.txt"
open(Sortie,">accent.adb");

#cat accentDebut.adb > accent.adb
open(Debut,"accentDebut.adb") || die("erreur dans l'ouverture de accentDebut.adb");
while (<Debut>)
{
	print Sortie "$_";
}
close(Debut);


#grep -v "^[[:space:]]*--" liste.txt | sed "s/\"/\"\&'\"'\&\"/g" | sed 's/\([^[:space:]]*\)[[:space:]]*\([^[:space:]]*\)[[:space:]]*\(.*\)/    tracerAide(" \1 \2 \3");/' >> accent.adb
my @ligne;
my $latex; # Code LaTeX de la diacritique
open(Liste,"liste.txt") || die("erreur dans l'ouverture de liste.txt");
while (<Liste>)
{
	chomp($_);
	if ($_)
	{
		@ligne=split();
		if ("$ligne[2]" =~ "\\\"[aeiouyAEIOUY]")
		{
			$ligne[2] =~ s/"/""/ ;
		}

    # Le code LaTeX de la diacritique peut etre compose de deux mots
    if (exists($ligne[3]))
    {
      $latex="$ligne[2] $ligne[3]";
    } else {
      $latex="$ligne[2]";
    }

		print Sortie "if (char = '$ligne[0]') then return \"$latex\"; end if;\n" unless /--/;
		
	}
}
close(Liste);

#cat accentFin.adb >> accent.adb
open(Fin,"accentFin.adb") || die("erreur dans l'ouverture de accentFin.adb");
while (<Fin>)
{
	print Sortie "$_" unless /--/;
}
close(Fin);

close(Sortie);
