--------------------------------------------------------------------------------
-- Trombi - Copyright 2007-2008 Louis Paternault
-- 
-- This file is part of Trombi.
-- 
-- Trombi is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
-- 
-- Trombi is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
-- 
-- You should have received a copy of the GNU General Public License
-- along with Trombi.  If not, see <http://www.gnu.org/licenses/>.
--------------------------------------------------------------------------------

--------------- ATTENTION -----------------------------------------
-- Il n'y a pour le moment pas de gestion serieuse de la memoire --
-------------------------------------------------------------------

with trace;
use trace;

package body piles is

  ----------------------------------------
  -- Gere les commentaires de debuggage --
  profMax : integer := 1;
  procedure tracer(prof : positive ; chaine : string) is
  begin
    if prof <= profMax then
      tracerDebug(prof, chaine);
    end if;
  end tracer;
  ----------------------------------------

  procedure empile(o : objet ; p : in out pile) is
  begin
    ajouteTete(o, p);
  end empile;

  procedure depile(o : out objet ; p : in out pile) is
  begin
    o := tete(p);
    p := suiteDestructive(p);
  end depile;

  function pileVide return pile is
  begin
    return listeVide;
  end pileVide;

  function estVide(p : pile) return boolean is
  begin
    return maListe.estVide(liste(p));
  end estVide;

end piles;
