--------------------------------------------------------------------------------
-- Trombi - Copyright 2007-2008 Louis Paternault
-- 
-- This file is part of Trombi.
-- 
-- Trombi is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
-- 
-- Trombi is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
-- 
-- You should have received a copy of the GNU General Public License
-- along with Trombi.  If not, see <http://www.gnu.org/licenses/>.
--------------------------------------------------------------------------------

-------------------------------------------
--
-- Pile
--
-------------------------------------------

with listes;

generic
  type objet is private;

package piles is


  package maListe is new listes(objet);
  use maListe;

  type pile is new liste;
  
  -- Empile l'objet 'o' sur la pile 'p'
  procedure empile(o : objet ; p : in out pile);

  -- Depile un objet de la pile 'p', et le renvoie
  procedure depile(o : out objet ; p : in out pile);

  -- Renvoieune pile vide
  function pileVide return pile;

  -- Renvoie 'true' ssi la pile 'p' est vide
  function estVide(p : pile) return boolean;

end piles;
